using System;
using System.Drawing;
using System.Collections;
using System.Configuration;
using System.ComponentModel;
using System.Windows.Forms;
using System.Diagnostics;
using System.Data;
using System.Data.SqlClient;
using System.Text;
using System.IO;
using System.Reflection;

namespace dexleapFTC
{
	/// <summary>
	/// Summary description for the Form.
	/// </summary>
	public class frmAppTest : System.Windows.Forms.Form
	{
		private System.Windows.Forms.GroupBox grpLeft;
		private System.Windows.Forms.TextBox txtSubmit;
		private System.Windows.Forms.Label lblSign;
		private System.Windows.Forms.Label lblEntryNum;
		private System.Windows.Forms.TextBox txtSearch;
		private System.Windows.Forms.Button btnSearch;
		private AxSHDocVw.AxWebBrowser axWebBrowser;
		private System.Windows.Forms.Button btnNewView;

		//how many entries one page can handle
		private int lPageUnit;
		//current page
		private int ixPage=0;
		//connection string
		private string asConn;
		
		//searched text
		private string sWordSearch="";
		
		//we input text chunk by chunk.
		//3000 nvarchar as a string chunk
		private int CHUNKSTRINGSIZE;
		
		//memo for dexleap
		private string sMemo="";
		
		//the web browser's default html	
		private string sCurrentPath;
		private System.Windows.Forms.Button btnList;
		private System.Windows.Forms.Panel panel1;
		private System.Windows.Forms.Label lblTotal;
		private System.Windows.Forms.Label lblIndexed;
		private System.Windows.Forms.Label lblIndexing;
		private System.Windows.Forms.LinkLabel btnLnk;
		private System.Windows.Forms.GroupBox grpRight;
		private System.Windows.Forms.Splitter splitter1;
		private System.Windows.Forms.Button btnIndex;
		/// <summary>
		/// Required designer variable.
		/// </summary>
		private System.ComponentModel.Container components = null;

		public frmAppTest()
		{
			//
			// Required for Windows Form Designer support
			//
			InitializeComponent();
			//
			// TODO: Add any constructor code after InitializeComponent call
			//
			//build connection string
			Dal_ConnStrBuild();	
			//default html path
			string _sHTMLFilePath = Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location) + "\\ax.htm";
			sCurrentPath = "file://"+_sHTMLFilePath;
			//just in case the text html file ax.html is not there, we create it here
			if (!File.Exists(_sHTMLFilePath))
			{
				FileStream _filestream = new FileStream(_sHTMLFilePath,FileMode.CreateNew);
				_filestream.Close(); 				
			}

			//init add/view status
			//0 means new text, non-0 means viewing an existing entry.
			SwapAddView(0);
			//wireup events
			btnNewView.Click += new EventHandler(btnNewView_Click);
			btnSearch.Click += new EventHandler(btnSearch_Click);
			btnList.Click += new EventHandler(btnList_Click);
			btnIndex.Click +=new EventHandler(btnIndex_Click);
			btnLnk.LinkClicked += new LinkLabelLinkClickedEventHandler(btnLnk_LinkClicked);
			axWebBrowser.NavigateComplete2 += new AxSHDocVw.DWebBrowserEvents2_NavigateComplete2EventHandler(axWebBrowser_NavigateComplete2); 
		
			
			try
			{
				//every time the form launching will cause db_attach to run.
				string _sExecutePath  = Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location) + "\\DB_Attach.bat";
				Process.Start(_sExecutePath);
				//render the latest page of the whole list
				ixPage=Dal_MaxPageNum();
				RenderEntryList(Dal_DtEntryList(ixPage));	
			}
			catch
			{
				//
				RenderAppError();
			}
			//web browser open
			axWebBrowser.Navigate(sCurrentPath); 
			
		}

		/// <summary>
		/// Clean up any resources being used.
		/// </summary>
		protected override void Dispose( bool disposing )
		{
			if( disposing )
			{
				if (components != null) 
				{
					components.Dispose();
				}
			}
			base.Dispose( disposing );
		}

		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			System.Resources.ResourceManager resources = new System.Resources.ResourceManager(typeof(frmAppTest));
			this.grpLeft = new System.Windows.Forms.GroupBox();
			this.btnLnk = new System.Windows.Forms.LinkLabel();
			this.lblEntryNum = new System.Windows.Forms.Label();
			this.lblSign = new System.Windows.Forms.Label();
			this.txtSubmit = new System.Windows.Forms.TextBox();
			this.btnNewView = new System.Windows.Forms.Button();
			this.grpRight = new System.Windows.Forms.GroupBox();
			this.btnIndex = new System.Windows.Forms.Button();
			this.panel1 = new System.Windows.Forms.Panel();
			this.lblIndexed = new System.Windows.Forms.Label();
			this.lblTotal = new System.Windows.Forms.Label();
			this.lblIndexing = new System.Windows.Forms.Label();
			this.btnList = new System.Windows.Forms.Button();
			this.axWebBrowser = new AxSHDocVw.AxWebBrowser();
			this.btnSearch = new System.Windows.Forms.Button();
			this.txtSearch = new System.Windows.Forms.TextBox();
			this.splitter1 = new System.Windows.Forms.Splitter();
			this.grpLeft.SuspendLayout();
			this.grpRight.SuspendLayout();
			this.panel1.SuspendLayout();
			((System.ComponentModel.ISupportInitialize)(this.axWebBrowser)).BeginInit();
			this.SuspendLayout();
			// 
			// grpLeft
			// 
			this.grpLeft.Controls.Add(this.btnLnk);
			this.grpLeft.Controls.Add(this.lblEntryNum);
			this.grpLeft.Controls.Add(this.lblSign);
			this.grpLeft.Controls.Add(this.txtSubmit);
			this.grpLeft.Controls.Add(this.btnNewView);
			this.grpLeft.Dock = System.Windows.Forms.DockStyle.Left;
			this.grpLeft.Location = new System.Drawing.Point(0, 0);
			this.grpLeft.Name = "grpLeft";
			this.grpLeft.Size = new System.Drawing.Size(213, 342);
			this.grpLeft.TabIndex = 3;
			this.grpLeft.TabStop = false;
			this.grpLeft.Text = "New/View";
			// 
			// btnLnk
			// 
			this.btnLnk.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.btnLnk.Font = new System.Drawing.Font("Microsoft Sans Serif", 9F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.btnLnk.Location = new System.Drawing.Point(9, 301);
			this.btnLnk.Name = "btnLnk";
			this.btnLnk.Size = new System.Drawing.Size(184, 33);
			this.btnLnk.TabIndex = 5;
			this.btnLnk.TabStop = true;
			this.btnLnk.Text = "www.dexleap.com";
			this.btnLnk.TextAlign = System.Drawing.ContentAlignment.MiddleCenter;
			// 
			// lblEntryNum
			// 
			this.lblEntryNum.Location = new System.Drawing.Point(20, 16);
			this.lblEntryNum.Name = "lblEntryNum";
			this.lblEntryNum.Size = new System.Drawing.Size(135, 14);
			this.lblEntryNum.TabIndex = 4;
			// 
			// lblSign
			// 
			this.lblSign.Location = new System.Drawing.Point(8, 16);
			this.lblSign.Name = "lblSign";
			this.lblSign.Size = new System.Drawing.Size(13, 15);
			this.lblSign.TabIndex = 3;
			this.lblSign.Text = "#";
			// 
			// txtSubmit
			// 
			this.txtSubmit.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txtSubmit.Location = new System.Drawing.Point(5, 38);
			this.txtSubmit.MaxLength = 300000;
			this.txtSubmit.Multiline = true;
			this.txtSubmit.Name = "txtSubmit";
			this.txtSubmit.ScrollBars = System.Windows.Forms.ScrollBars.Vertical;
			this.txtSubmit.Size = new System.Drawing.Size(204, 233);
			this.txtSubmit.TabIndex = 3;
			this.txtSubmit.Text = "";
			// 
			// btnNewView
			// 
			this.btnNewView.Anchor = System.Windows.Forms.AnchorStyles.Bottom;
			this.btnNewView.Location = new System.Drawing.Point(38, 281);
			this.btnNewView.Name = "btnNewView";
			this.btnNewView.Size = new System.Drawing.Size(120, 19);
			this.btnNewView.TabIndex = 4;
			// 
			// grpRight
			// 
			this.grpRight.Controls.Add(this.btnIndex);
			this.grpRight.Controls.Add(this.panel1);
			this.grpRight.Controls.Add(this.lblIndexing);
			this.grpRight.Controls.Add(this.btnList);
			this.grpRight.Controls.Add(this.axWebBrowser);
			this.grpRight.Controls.Add(this.btnSearch);
			this.grpRight.Controls.Add(this.txtSearch);
			this.grpRight.Dock = System.Windows.Forms.DockStyle.Fill;
			this.grpRight.Location = new System.Drawing.Point(213, 0);
			this.grpRight.Name = "grpRight";
			this.grpRight.Size = new System.Drawing.Size(293, 342);
			this.grpRight.TabIndex = 4;
			this.grpRight.TabStop = false;
			this.grpRight.Text = "Search";
			// 
			// btnIndex
			// 
			this.btnIndex.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.btnIndex.Location = new System.Drawing.Point(65, 281);
			this.btnIndex.Name = "btnIndex";
			this.btnIndex.Size = new System.Drawing.Size(72, 19);
			this.btnIndex.TabIndex = 100;
			this.btnIndex.Text = "Index Now";
			// 
			// panel1
			// 
			this.panel1.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.panel1.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.panel1.Controls.Add(this.lblIndexed);
			this.panel1.Controls.Add(this.lblTotal);
			this.panel1.Location = new System.Drawing.Point(152, 281);
			this.panel1.Name = "panel1";
			this.panel1.Size = new System.Drawing.Size(119, 48);
			this.panel1.TabIndex = 99;
			// 
			// lblIndexed
			// 
			this.lblIndexed.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.lblIndexed.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblIndexed.Location = new System.Drawing.Point(9, 25);
			this.lblIndexed.Name = "lblIndexed";
			this.lblIndexed.Size = new System.Drawing.Size(94, 13);
			this.lblIndexed.TabIndex = 8;
			this.lblIndexed.Text = "Indexed:";
			this.lblIndexed.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// lblTotal
			// 
			this.lblTotal.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.lblTotal.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblTotal.Location = new System.Drawing.Point(9, 8);
			this.lblTotal.Name = "lblTotal";
			this.lblTotal.Size = new System.Drawing.Size(93, 13);
			this.lblTotal.TabIndex = 7;
			this.lblTotal.Text = "Total:";
			this.lblTotal.TextAlign = System.Drawing.ContentAlignment.MiddleLeft;
			// 
			// lblIndexing
			// 
			this.lblIndexing.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
			this.lblIndexing.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.lblIndexing.Font = new System.Drawing.Font("Microsoft Sans Serif", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((System.Byte)(0)));
			this.lblIndexing.Location = new System.Drawing.Point(65, 315);
			this.lblIndexing.Name = "lblIndexing";
			this.lblIndexing.Size = new System.Drawing.Size(72, 14);
			this.lblIndexing.TabIndex = 6;
			this.lblIndexing.TextAlign = System.Drawing.ContentAlignment.MiddleRight;
			// 
			// btnList
			// 
			this.btnList.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnList.Location = new System.Drawing.Point(247, 14);
			this.btnList.Name = "btnList";
			this.btnList.Size = new System.Drawing.Size(39, 18);
			this.btnList.TabIndex = 2;
			this.btnList.Text = "List";
			// 
			// axWebBrowser
			// 
			this.axWebBrowser.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
				| System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.axWebBrowser.ContainingControl = this;
			this.axWebBrowser.Enabled = true;
			this.axWebBrowser.Location = new System.Drawing.Point(6, 38);
			this.axWebBrowser.OcxState = ((System.Windows.Forms.AxHost.State)(resources.GetObject("axWebBrowser.OcxState")));
			this.axWebBrowser.Size = new System.Drawing.Size(283, 229);
			this.axWebBrowser.TabIndex = 2;
			this.axWebBrowser.TabStop = false;
			// 
			// btnSearch
			// 
			this.btnSearch.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Right)));
			this.btnSearch.Location = new System.Drawing.Point(191, 14);
			this.btnSearch.Name = "btnSearch";
			this.btnSearch.Size = new System.Drawing.Size(50, 18);
			this.btnSearch.TabIndex = 1;
			this.btnSearch.Text = "Search";
			// 
			// txtSearch
			// 
			this.txtSearch.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left) 
				| System.Windows.Forms.AnchorStyles.Right)));
			this.txtSearch.Location = new System.Drawing.Point(6, 14);
			this.txtSearch.Name = "txtSearch";
			this.txtSearch.Size = new System.Drawing.Size(177, 20);
			this.txtSearch.TabIndex = 0;
			this.txtSearch.Text = "Exchange forgiveness with me";
			// 
			// splitter1
			// 
			this.splitter1.Location = new System.Drawing.Point(213, 0);
			this.splitter1.Name = "splitter1";
			this.splitter1.Size = new System.Drawing.Size(2, 342);
			this.splitter1.TabIndex = 5;
			this.splitter1.TabStop = false;
			// 
			// frmAppTest
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 13);
			this.ClientSize = new System.Drawing.Size(506, 342);
			this.Controls.Add(this.splitter1);
			this.Controls.Add(this.grpRight);
			this.Controls.Add(this.grpLeft);
			this.Name = "frmAppTest";
			this.Text = "Full Text Care (FTC) Demo For MSDE/MS SQL Server    www.dexleap.com";
			this.grpLeft.ResumeLayout(false);
			this.grpRight.ResumeLayout(false);
			this.panel1.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize)(this.axWebBrowser)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion

		/// <summary>
		/// The main entry point for the application.
		/// </summary>
		[STAThread]
		static void Main() 
		{
			Application.Run(new frmAppTest());
		}

		//connection string constructor
		private void Dal_ConnStrBuild()
		{
			//3000 is a hard code number.
			CHUNKSTRINGSIZE  = 3000;
			asConn = ConfigurationSettings.AppSettings["CONNSTR"];
			lPageUnit = Convert.ToInt32(ConfigurationSettings.AppSettings["PAGEUNIT"]);
			//server=blank is the default setup
			asConn = asConn.Replace("blank",Environment.MachineName);

			//this is the memo for dexleap.com
			sMemo =		 "<font size=2><li>Easy and Fast</li>" +
						 "<li>Multiple languages</li>" +
						 "<li>Running on MSDE and MS SQL server</li>" +
						 "<li>No hidden services.You control the whole procedure</li>" +
						 "<li>Get the Full Text Care(FTC) Learning Kit from www.dexleap.com</li>"; 

		}

		//ready to index
		private void Dal_EntryReadyToIndex (int _ixArchiveEntry)
		{
		
			SqlConnection _conn = new SqlConnection();
			_conn.ConnectionString = asConn;

			SqlCommand _cmd = new SqlCommand ("up_EntryReadyToIndex",_conn);
			_cmd.CommandType = CommandType.StoredProcedure;
			_cmd.Parameters.Add("@ixArchiveEntry",_ixArchiveEntry);
			_cmd.Parameters["@ixArchiveEntry"].Direction = ParameterDirection.Input;

			_conn.Open();
		
			_cmd.ExecuteNonQuery();

			_conn.Close();

		}

		//wordsearch function will list the search result 
		//This function will return 3 tables, (1)the search result; (2)the search phrase table; (3) the procresult (maxpage,millisec)
		public DataSet Dal_DsWordSearch()
		{
			SqlDataAdapter _daWordSearch;
			DataSet _dsWordSearch = new DataSet();
			SqlConnection _conn = new SqlConnection();

			_conn.ConnectionString = asConn;
		
			// A SqlCommand object is used to execute the SQL commands.
			SqlCommand _cmd = new SqlCommand();
			_cmd.Connection = _conn;
			_cmd.CommandType = CommandType.StoredProcedure;
			//search proc
			_cmd.CommandText = "up_WordSearch";

			_cmd.Parameters.Add("@sWordSearch",sWordSearch);
			_cmd.Parameters["@sWordSearch"].Direction = ParameterDirection.Input;
			
			_cmd.Parameters.Add("@ixPage",ixPage);
			_cmd.Parameters["@ixPage"].Direction = ParameterDirection.Input;

			_cmd.Parameters.Add("@lPageUnit",lPageUnit);
			_cmd.Parameters["@lPageUnit"].Direction = ParameterDirection.Input;
		
			// A SqlDataAdapter uses the SqlCommand object to fill a DataSet.
			_daWordSearch = new SqlDataAdapter(_cmd);
			_conn.Open();
			//fill the Group table (dynamic from sp)
			//_daWordSearch.Fill(_dsWordSearch,"upWordSearch");
			//table 0 is the main search result;table 1 is the phrase table
			_daWordSearch.Fill(_dsWordSearch);
			//make sure to close the connection
			_conn.Close(); 
			// return the filled DataSet
			return _dsWordSearch;
		}

		
		//return the  text from a given ixArchiveEntry
		private string Dal_sEntryText(int _ixArchiveEntry)
		{
		
			string _sEntryText;
			SqlConnection _conn = new SqlConnection();
			_conn.ConnectionString = asConn;
			_conn.Open();
		
			// A SqlCommand object is used to execute the SQL commands.
			SqlCommand _cmd = new SqlCommand();
			_cmd.Connection = _conn;
			_cmd.CommandType = CommandType.StoredProcedure;
			_cmd.CommandText = "up_EntryContent";

		
			_cmd.Parameters.Add("@ixArchiveEntry",_ixArchiveEntry);
			_cmd.Parameters["@ixArchiveEntry"].Direction = ParameterDirection.Input;
		
			//fill text
			_sEntryText = Convert.ToString(_cmd.ExecuteScalar());
			//make sure to close the connection
			_conn.Close(); 
			
			// return the long string
			return _sEntryText ; 
		}
		//Add an entry to DB and return the just created entry number
		private int Dal_IxEntryAdd()
		{
			int _ixArchiveEntry;
			SqlConnection _conn = new SqlConnection();
			_conn.ConnectionString = asConn;
			// A SqlCommand object is used to execute the SQL commands.
			SqlCommand _cmd = new SqlCommand();
			_cmd.Connection = _conn;
			_cmd.CommandType = CommandType.StoredProcedure;
			//Topic Add proc
			_cmd.CommandText = "up_EntryAdd";
			_conn.Open();
			//Run
			_ixArchiveEntry = Convert.ToInt32(_cmd.ExecuteScalar());
			//make sure to close the connection
			_conn.Close(); 
			// return the just created ixArchiveEntry
			return _ixArchiveEntry;
		}		

		//Return the Max PageNum
		private int Dal_MaxPageNum()
		{
			int _maxPageNum;
			SqlConnection _conn = new SqlConnection();
			_conn.ConnectionString = asConn;
			// A SqlCommand object is used to execute the SQL commands.
			SqlCommand _cmd = new SqlCommand();
			_cmd.Connection = _conn;
			_cmd.CommandType = CommandType.StoredProcedure;
			//Topic Add proc
			_cmd.CommandText = "up_MaxPageNum";
			_cmd.Parameters.Add("@lPageUnit",lPageUnit);
			_cmd.Parameters["@lPageUnit"].Direction = ParameterDirection.Input;
			_conn.Open();
			//Run
			_maxPageNum = Convert.ToInt32(_cmd.ExecuteScalar());
			//make sure to close the connection
			_conn.Close(); 
			// return the just created ixArchiveEntry
			return _maxPageNum;
		}		

		
		//return a datatable which will show the current indexing entry and total/indexed ration
		private DataTable Dal_DtWordIndexProgress()
		{
			SqlDataAdapter _da;
			DataTable _dtWordIndexProgress = new DataTable();
		
			SqlConnection _conn = new SqlConnection();
			_conn.ConnectionString = asConn;
			_conn.Open();
		
			// A SqlCommand object is used to execute the SQL commands.
			SqlCommand _cmd = new SqlCommand();
			_cmd.Connection = _conn;
			_cmd.CommandType = CommandType.StoredProcedure;
			_cmd.CommandText = "up_WordIndexProgress";

		
			//fill datatable instead of a dataset
			_da = new SqlDataAdapter(_cmd);
			_da.Fill(_dtWordIndexProgress);
		
			//make sure to close the connection
			_conn.Close(); 
			
			// return the table
			return _dtWordIndexProgress; 
		}

		//Force the Index to start all over again
		//We never use this in the demo
		private void Dal_WordIndexStartOver()
		{
			SqlConnection _conn = new SqlConnection();
			_conn.ConnectionString = asConn;
			// A SqlCommand object is used to execute the SQL commands.
			SqlCommand _cmd = new SqlCommand();
			_cmd.Connection = _conn;
			_cmd.CommandType = CommandType.StoredProcedure;
			//Make all the indexed entries as "ready to index" status
			_cmd.CommandText = "up_WordIndexStartOver";
			
			_conn.Open();
			//Run
			_cmd.ExecuteNonQuery();
			//make sure to close the connection
			_conn.Close(); 
		}		

		//Start or Stop indexing process
		private void Dal_WordIndexControl(string _ynDoIndex)
		{
			SqlConnection _conn = new SqlConnection();
			_conn.ConnectionString = asConn;
			// A SqlCommand object is used to execute the SQL commands.
			SqlCommand _cmd = new SqlCommand();
			_cmd.Connection = _conn;
			_cmd.CommandType = CommandType.StoredProcedure;
			//Topic Add proc
			_cmd.CommandText = "up_WordIndexControl";

			_cmd.Parameters.Add("@ynDoIndex",_ynDoIndex);
			_cmd.Parameters["@ynDoIndex"].Direction = ParameterDirection.Input;
			
			_conn.Open();
			//Run
			_cmd.ExecuteNonQuery();
			
			//make sure to close the connection
			_conn.Close(); 
		}		

		//Remove an entry from DB
		private void Dal_EntryRemove(int _ixArchiveEntry)
		{
			SqlConnection _conn = new SqlConnection();
			_conn.ConnectionString = asConn;
			// A SqlCommand object is used to execute the SQL commands.
			SqlCommand _cmd = new SqlCommand();
			_cmd.Connection = _conn;
			_cmd.CommandType = CommandType.StoredProcedure;
			//Topic Add proc
			_cmd.CommandText = "up_EntryRemove";

			_cmd.Parameters.Add("@ixArchiveEntry",_ixArchiveEntry);
			_cmd.Parameters["@ixArchiveEntry"].Direction = ParameterDirection.Input;
			
			_conn.Open();
			//Run
			_cmd.ExecuteNonQuery();
			//make sure to close the connection
			_conn.Close(); 
		}		
		
		//Add text  chunk into database
		private void Dal_EntryAddText(int _ixArchiveEntry, string _sInput)
		{

			int _lenInput = _sInput.Length;
			int _ixChunkPos = 0;
		
			string _sChunk = "";

			SqlConnection _conn = new SqlConnection();
			_conn.ConnectionString = asConn;

			SqlCommand _cmd = new SqlCommand ("up_EntryAddStringChunk",_conn);
			_cmd.CommandType = CommandType.StoredProcedure;
			_cmd.Parameters.Add("@ixArchiveEntry",_ixArchiveEntry);
			_cmd.Parameters["@ixArchiveEntry"].Direction = ParameterDirection.Input;

			_cmd.Parameters.Add("@sStringChunk",SqlDbType.NVarChar);
			_cmd.Parameters["@sStringChunk"].Direction = ParameterDirection.Input;

			_conn.Open();
		
			while ( _ixChunkPos + CHUNKSTRINGSIZE < _lenInput)
			{
			
				_sChunk = _sInput.Substring(_ixChunkPos,CHUNKSTRINGSIZE); 
				_cmd.Parameters["@sStringChunk"].Value = _sChunk;
				_cmd.ExecuteNonQuery();

				//next chunk pos 
				_ixChunkPos = _ixChunkPos + CHUNKSTRINGSIZE;
			
			}
			//rest chunksize
			_sChunk = _sInput.Substring(_ixChunkPos);
			_cmd.Parameters["@sStringChunk"].Value = _sChunk; 
			_cmd.ExecuteNonQuery();

			_conn.Close();
		}

		//List entries 
		private DataTable Dal_DtEntryList (int _ixPage)
		{
			SqlDataAdapter _daEntryList;
			DataTable _dtEntryList = new DataTable();

			SqlConnection _conn = new SqlConnection();

			_conn.ConnectionString = asConn;
		
			// A SqlCommand object is used to execute the SQL commands.
			SqlCommand _cmd = new SqlCommand();
			_cmd.Connection = _conn;
			_cmd.CommandType = CommandType.StoredProcedure;
			//Group List
			_cmd.CommandText = "up_EntryList";

			//Paging
			_cmd.Parameters.Add("@ixPage",_ixPage);
			_cmd.Parameters["@ixPage"].Direction = ParameterDirection.Input;
		
			_cmd.Parameters.Add("@lPageUnit",lPageUnit);
			_cmd.Parameters["@lPageUnit"].Direction = ParameterDirection.Input;
		
			// A SqlDataAdapter uses the SqlCommand object to fill a DataSet.
			_daEntryList = new SqlDataAdapter(_cmd);

			_conn.Open();
			//fill the Group table (dynamic from sp)
			_daEntryList.Fill(_dtEntryList);
		
			//make sure to close the connection
			_conn.Close(); 
			
			// return the filled DataTable
			return _dtEntryList;
		}


		//Swap the addview status (either add or view)
		private void SwapAddView(int _ixArchiveEntry)
	    {
			if (0==_ixArchiveEntry)
			{
				lblEntryNum.Text = "";
				txtSubmit.Text = "";
				btnNewView.Text = "Add New Entry";
			}
			else
			{
				lblEntryNum.Text = _ixArchiveEntry.ToString();
				btnNewView.Text = "Back";
			}
	    }

		//go to home page
		private void btnLnk_LinkClicked(object sender, LinkLabelLinkClickedEventArgs e)
		{
			System.Diagnostics.Process.Start("http://www.dexleap.com");
		}

		//click EntryList
		private void btnList_Click(object sender, EventArgs e)
		{
			//render the latest page of the whole list
			ixPage=Dal_MaxPageNum();
			RenderEntryList(Dal_DtEntryList(ixPage));	
			
			//open web browser
			axWebBrowser.Navigate(sCurrentPath); 
			
		}

		//click search
		private void btnSearch_Click(object sender, EventArgs e)
		{
			sWordSearch = txtSearch.Text.Trim();
			if (""!=sWordSearch)
			{
				//render the latest page of the whole list
				ixPage = 0;
				RenderSearchResult(Dal_DsWordSearch());	
				//web browser open
				axWebBrowser.Navigate(sCurrentPath); 
			}
			else
			{
				sWordSearch = "";
				axWebBrowser.Navigate("about:"+ sMemo); 
			}
			
		}
		
		//Index Start
		private void btnIndex_Click(object sender, EventArgs e)
		{
			string _sExecutePath = "";
			try
			{
				_sExecutePath  = Path.GetDirectoryName(Assembly.GetExecutingAssembly().Location) + "\\DB_startindex.bat";
				Process.Start(_sExecutePath);
				
			}
			catch (Exception _ex)
			{
				MessageBox.Show(_ex.Message);
			}
			
		}
		
		//click new/view
		private void btnNewView_Click(object sender, EventArgs e)
		{
			
			string _sInput=txtSubmit.Text.Trim();
			int _ixArchiveEntryNew;
			
			//add new entry
			if(""==lblEntryNum.Text)
			{
				if (0==_sInput.Length)
				{
					MessageBox.Show("Text can't be blank.");
				}
				else
				{
						//add the entry
						_ixArchiveEntryNew = Dal_IxEntryAdd();
						//text get in
						Dal_EntryAddText(_ixArchiveEntryNew,_sInput);
						//ready to index
						Dal_EntryReadyToIndex(_ixArchiveEntryNew);
						MessageBox.Show("Done.");
				
						//refresh  the html
						ixPage = Dal_MaxPageNum();
						RenderEntryList(Dal_DtEntryList(ixPage));	
						//open the default page again.
						axWebBrowser.Navigate(sCurrentPath); 

						//ready to add another new entry
						SwapAddView(0);
						
					
				}
			}
			//go back to blank status
			else
			{
				SwapAddView(0);
			}
			//update indexed / total ration
			RefreshIndexProgress();
		}

		
		private void axWebBrowser_NavigateComplete2(object sender, AxSHDocVw.DWebBrowserEvents2_NavigateComplete2Event e)
		{
			string _sURL = axWebBrowser.LocationURL.ToString();
			string _sURLinit = _sURL.Substring(0,1);
			
			int	_ixEntryOrPage;
			//about:v16  or about:d16 or about:p3 (go to page 3) or about:s3 (go to searched result page 3)
			if ("a"==_sURLinit)
			{
				//get ixArchiveEntry
				_ixEntryOrPage = Convert.ToInt32(_sURL.Substring(7));
				axWebBrowser.Visible = false; 
				if ("v"==_sURL.Substring(6,1))
				{
					//"v" means to view the entry
					SwapAddView(_ixEntryOrPage);
					txtSubmit.Text = Dal_sEntryText(_ixEntryOrPage);
					//rerender the html
					axWebBrowser.GoBack(); 

				}
				else if ("r"==_sURL.Substring(6,1))
				{
					
					//"r" means to remove the entry
					DialogResult result = 
						MessageBox.Show("Really remove this?", 
						"Confirm remove", 
						MessageBoxButtons.OKCancel); 
					if (result == DialogResult.OK)
					{
						Dal_EntryRemove(_ixEntryOrPage);
					}
					//rerender the html from the latest page rerendering
					RenderEntryList(Dal_DtEntryList(ixPage));	
					//open the default page again.
					axWebBrowser.Navigate(sCurrentPath); 
				}
				//search different page _ixEntryOrPage
				else if ("s"==_sURL.Substring(6,1))
				{
					//"s" means that we are going to search this page
					ixPage=_ixEntryOrPage;
					//rerender the html
					RenderSearchResult(Dal_DsWordSearch());	
					//open the default page again.
					axWebBrowser.Navigate(sCurrentPath); 
				}
				//go different page _ixEntryOrPage
				else
				{
					ixPage=_ixEntryOrPage;
					//rerender the html
					RenderEntryList(Dal_DtEntryList(ixPage));	
					//open the default page again.
					axWebBrowser.Navigate(sCurrentPath); 
				}
				axWebBrowser.Visible = true; 
			}

			//total/indexed ratio
			RefreshIndexProgress();

		}

		//Just in case DB connection is wrong
		private void RenderAppError()
		{
			FileStream _filestream = null;
			TextWriter _tw = null; 
			try
			{
				//open a brand new ax.htm
				_filestream = new FileStream("ax.htm",FileMode.Truncate);
				_tw = new StreamWriter(_filestream,Encoding.UTF8); 
				//write to file
				_tw.Write("<h4><font color=blue>The database is not setup properly.<br> " +
						 "Please close this program and refer to the user guide.</font></h4><br><br>" +
						 sMemo); 
				//disable function keys
				btnNewView.Enabled = false;
				btnIndex.Enabled = false;
				btnSearch.Enabled = false;
				btnList.Enabled =false;
			}
			catch (Exception _ex)
			{
				// Trap the error, if any.
				MessageBox.Show(_ex.Message);
			}
			finally
			{
				if (null != _tw)
				{
					//Safely Close the file.
					_tw.Close();
				}
				if (null != _filestream)
				{
					_filestream.Close();
				}
			}
				
		}

		
		//normal entry list 
		private void RenderEntryList(DataTable _dtEntryList)
		{
			
			StringBuilder _sb = new StringBuilder();
			FileStream _filestream = null;
			TextWriter _tw = null; 

			string _sPostDate;
			string _sPageNum;
			int _ixArchiveEntry;
			int _maxPageNum = Dal_MaxPageNum();
			string _sEntryBrief;

			string _sStylePage = 
			"style = \"font: statusbar;color:black;text-align: left;\"";

			string _sStyleHeader = 
				"style = \"font: statusbar;color:green;background-color:whitesmoke;text-align: left;\"";

			//page<table>
			_sPageNum = "<table width=100%><tr><td " + _sStylePage + ">&nbsp;Entry List Page:";
			for(int _ixLoop=_maxPageNum;_ixLoop>0 ;_ixLoop--)
			{
				//hyperlink will show up if it is non-current page number
				if (ixPage!=_ixLoop)
				{
					_sPageNum = _sPageNum +" <a href=about:p" +_ixLoop.ToString() +">"+_ixLoop.ToString()+ "</a>";
				}
					//current page number will cause no hyperlink at all
				else
				{
					_sPageNum = _sPageNum + " "+_ixLoop.ToString();
							
				}
			}

			_sPageNum = _sPageNum + "</td></tr></table>";

			//content <table>
			_sb.Append("<table width=100%>");
			for(int _ixLoop=0; _ixLoop < _dtEntryList.Rows.Count ;_ixLoop++)
			{
					
				DataRow _drEntryListRow = _dtEntryList.Rows[_ixLoop];

				_sb.Append("<tr><td align=left><table width=100% cellpadding=1 cellspacing=0><tr><td "+ _sStyleHeader +">");
				//Line Info.
				_sPostDate = _drEntryListRow["sPostDate"].ToString();
				_ixArchiveEntry = Convert.ToInt32(_drEntryListRow["ixArchiveEntry"]);
				//line brief content (clean up some html tags)
				_sEntryBrief = StringParse(_drEntryListRow["sEntryTextFirstChunk"].ToString());
				
				
				//#123  post@2006-03-05
				_sb.Append("#"+_ixArchiveEntry.ToString()+"</td><td "+ _sStyleHeader +">");
				_sb.Append("post@"+_sPostDate+"</td><td "+ _sStyleHeader +">");

				//[view] [delete]
				_sb.Append("["+"<a href=about:v" +_ixArchiveEntry.ToString() +">View</a>]</td><td "+ _sStyleHeader +">");
				_sb.Append("["+"<a href=about:r" +_ixArchiveEntry.ToString() +">Delete</a>]</td></tr></table></td></tr>");
	
				//breif content line
				_sb.Append("<tr><td align=left>");
				_sb.Append(_sEntryBrief+"</td></tr>");

			}
			//end of page
			_sb.Append("</table>"); 

			try
			{
				//open a brand new ax.htm
				_filestream = new FileStream("ax.htm",FileMode.Truncate);
				_tw = new StreamWriter(_filestream,Encoding.UTF8); 
				//write to file
				_tw.Write(_sPageNum + "-----------" + 
					_sb.ToString() + "<br>-----------"+ _sPageNum); 
			}
			catch (Exception _ex)
			{
				// Trap the error, if any.
				MessageBox.Show(_ex.Message);
			}
			finally
			{
				if (null != _tw)
				{
					//Safely Close the file.
					_tw.Close();
				}
				if (null != _filestream)
				{
					_filestream.Close();
				}
			}
				
		}

		//List the search result 
		private void RenderSearchResult(DataSet _dsWordSearch)
		{
			
			StringBuilder _sb = new StringBuilder();
			FileStream _filestream = null;
			TextWriter _tw = null; 

			DataTable _dtSearchResult = _dsWordSearch.Tables[0];
			DataTable _dtProcResult= _dsWordSearch.Tables[1];
			DataTable _dtWordPhraseTable = _dsWordSearch.Tables[2];
			
			DataRow _drProcResult = _dtProcResult.Rows[0];

			string _sStringBrief;
			string _sPostDate;
			string _sPageNum;
			string _sPhrase;
			

			int _ixArchiveEntry;
			int _maxPageNum = Convert.ToInt32(_drProcResult["maxPageNum"]);
			float _fSecondTake = Convert.ToSingle(_drProcResult["millisec"])/1000; 

			

			string _sStylePage = 
				"style = \"font: statusbar;color:black;text-align: left;\"";

			string _sStyleHeader = 
				"style = \"font: statusbar;color:green;background-color:whitesmoke;text-align: left;\"";

			//just in case
			if(0==ixPage)
			{
				ixPage = _maxPageNum;
			}

			//page<table>
			_sPageNum = "<table width=100%><tr><td " + _sStylePage + ">&nbsp;Searched Result Page:";
			for(int _ixLoop=_maxPageNum;_ixLoop>0 ;_ixLoop--)
			{
				//hyperlink will show up if it is non-current page number
				if (ixPage!=_ixLoop)
				{
					_sPageNum = _sPageNum + " <a href=about:s" +_ixLoop.ToString() +">"+_ixLoop.ToString()+ "</a>";
				}
					//current page number will cause no hyperlink at all
				else
				{
					_sPageNum = _sPageNum + " "+_ixLoop.ToString();
							
				}
			}

			_sPageNum = _sPageNum + "</td></tr><tr><td " + _sStylePage + ">&nbsp;";
			_sPageNum = _sPageNum + "(" + _fSecondTake.ToString() + " seconds)</td></tr></table><br>";


			//content <table>
			_sb.Append("<table width=100%>");
			for(int _ixLoop=0; _ixLoop < _dtSearchResult.Rows.Count ;_ixLoop++)
			{
					
				DataRow _drSearchResultRow = _dtSearchResult.Rows[_ixLoop];

				_sb.Append("<tr><td align=left><table width=100% cellpadding=1 cellspacing=0><tr><td "+ _sStyleHeader +">");
				//Line Info.
				_sPostDate = _drSearchResultRow["sPostDate"].ToString();
				_ixArchiveEntry = Convert.ToInt32(_drSearchResultRow["ixArchiveEntry"]);
				//line brief content (clean up some html tags)
				_sStringBrief = StringParse(_drSearchResultRow["sStringBrief"].ToString());
				//Highlite phrase to <font class=HighLiter>phrase</font>
				
				for(int _ixLoopInner=0; _ixLoopInner< _dtWordPhraseTable.Rows.Count ;_ixLoopInner++)
				{
					DataRow _drWordPhraseTableRow = _dtWordPhraseTable.Rows[_ixLoopInner];
					_sPhrase = _drWordPhraseTableRow["sPhraseFromInput"].ToString();
					_sStringBrief = _sStringBrief.Replace(_sPhrase,"<font style=\"background-color: yellow;\">"+_sPhrase+"</font>");
				}
				
				//#123  post@2006-03-05
				_sb.Append("#"+_ixArchiveEntry.ToString()+"</td><td "+ _sStyleHeader +">");
				_sb.Append("post@"+_sPostDate+"</td><td "+ _sStyleHeader +">");

				//[view]
				_sb.Append("["+"<a href=about:v" +_ixArchiveEntry.ToString() +">View</a>]</td></tr></table>");

				//breif content line
				_sb.Append("<tr><td align=left>");
				_sb.Append(_sStringBrief+"</td></tr>");
	
				
			}
			//end of page
			_sb.Append("</table>"); 




			try
			{
				//open a brand new ax.htm
				_filestream = new FileStream("ax.htm",FileMode.Truncate);
				_tw = new StreamWriter(_filestream,Encoding.UTF8); 
				//write to file
				_tw.Write(_sPageNum + "-----------"+ 
						_sb.ToString() + "<br>-----------"+_sPageNum); 
			}
			catch (Exception _ex)
			{
				// Trap the error, if any.
				MessageBox.Show(_ex.Message);
			}
			finally
			{
				if (null != _tw)
				{
					//Safely Close the file.
					_tw.Close();
				}
				if (null != _filestream)
				{
					_filestream.Close();
				}
			}
				
		}


		//replace html tag with non-html-tag 
		private string StringParse(string _sString)
		{
			string _sReturn;
			string _sTemp = _sString;
			StringBuilder _sbStringBuilder = new StringBuilder(_sTemp);
			//&
			_sbStringBuilder.Replace("&","&amp;");
			//"
			_sbStringBuilder.Replace("\"","&quot;");
			//'
			_sbStringBuilder.Replace("'","&#39;");
			//<
			_sbStringBuilder.Replace("<","&lt;");
			//>
			_sbStringBuilder.Replace(">","&gt;");
			// \/
			_sbStringBuilder.Replace("\\","&#92;");
			_sbStringBuilder.Replace("/","&#47;");
			//carriage return and line feed
			_sbStringBuilder.Replace("\r","<br>");
			//_sbStringBuilder.Replace("\n","<br>");
			//tab
			_sbStringBuilder.Replace("\t","&nbsp;&nbsp;&nbsp;");
			_sReturn = _sbStringBuilder.ToString().Trim();

			return _sReturn;
		}

		//progress refresh
		private void RefreshIndexProgress()
		{
			DataTable _dt;
			DataRow _dr;
			int _cntTotal;
			int _cntIndexed;
			int _ixIndexing;
			
			//peek over the status in db level
			_dt = Dal_DtWordIndexProgress();
			_dr = _dt.Rows[0];
			_cntTotal = Convert.ToInt32(_dr["cntTotal"]);
			_cntIndexed = Convert.ToInt32(_dr["cntIndexed"]);
			_ixIndexing = Convert.ToInt32(_dr["ixIndexing"]);
			
			//Refresh UI
			lblTotal.Text = "Total: "+_cntTotal.ToString();
			lblIndexed.Text = "Indexed: " + _cntIndexed.ToString();
			lblIndexing.Text = "#"+_ixIndexing.ToString();
	

		}
	
	}


	
}
